diff --git a/src/xterm.c b/src/xterm.c
index 5aa3e3f..953a104 100644
--- a/src/xterm.c
+++ b/src/xterm.c
@@ -999,6 +1862,15 @@ x_update_begin (struct frame *f)
   if (FRAME_TOOLTIP_P (f) && !FRAME_VISIBLE_P (f))
     return;
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  f->mc_updating_frame = f;
+
+/* *************************************************************************** */
+
+
   if (! FRAME_CR_SURFACE (f))
     {
       int width, height;
@@ -1266,6 +2138,16 @@ x_update_end (struct frame *f)
   XFlush (FRAME_X_DISPLAY (f));
   unblock_input ();
 #endif
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  f->mc_updating_frame = NULL;
+
+/* *************************************************************************** */
+
+
 }
 
 /* This function is called from various places in xdisp.c
@@ -13100,6 +13982,21 @@ x_activate_timeout_atimer (void)
 
 static struct redisplay_interface x_redisplay_interface =
   {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+/* `redisplay_interface' in `xterm.c` must be in the exact same order as the
+`redisplay_interface' in `dispextern.h`! */
+
+  mc_x_write_glyphs,
+  mc_x_draw_window_cursor,
+  mc_x_draw_glyph_string,
+
+/* *************************************************************************** */
+
+
     x_frame_parm_handlers,
     x_produce_glyphs,
     x_write_glyphs,
